// This file was generated by qtwaylandscanner
// source file is ../protocol/dde-shell.xml

#include "qwayland-server-dde-shell.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWaylandServer {
    dde_surface_manager::dde_surface_manager(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(client, id, version);
    }

    dde_surface_manager::dde_surface_manager(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(display, version);
    }

    dde_surface_manager::dde_surface_manager(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(resource);
    }

    dde_surface_manager::dde_surface_manager()
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
    }

    dde_surface_manager::~dde_surface_manager()
    {
        for (auto resource : qAsConst(m_resource_map))
            resource->dde_surface_manager_object = nullptr;

        if (m_resource)
            m_resource->dde_surface_manager_object = nullptr;

        if (m_global) {
            wl_global_destroy(m_global);
            wl_list_remove(&m_displayDestroyedListener.link);
        }
    }

    void dde_surface_manager::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void dde_surface_manager::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    dde_surface_manager::Resource *dde_surface_manager::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    dde_surface_manager::Resource *dde_surface_manager::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void dde_surface_manager::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::dde_surface_manager_interface, version, this, bind_func);
        m_globalVersion = version;
        m_displayDestroyedListener.notify = dde_surface_manager::display_destroy_func;
        m_displayDestroyedListener.parent = this;
        wl_display_add_destroy_listener(display, &m_displayDestroyedListener);
    }

    const struct wl_interface *dde_surface_manager::interface()
    {
        return &::dde_surface_manager_interface;
    }

    dde_surface_manager::Resource *dde_surface_manager::dde_surface_manager_allocate()
    {
        return new Resource;
    }

    void dde_surface_manager::dde_surface_manager_bind_resource(Resource *)
    {
    }

    void dde_surface_manager::dde_surface_manager_destroy_resource(Resource *)
    {
    }

    void dde_surface_manager::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        dde_surface_manager *that = static_cast<dde_surface_manager *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void dde_surface_manager::display_destroy_func(struct ::wl_listener *listener, void *data)
    {
        Q_UNUSED(data);
        dde_surface_manager *that = static_cast<dde_surface_manager::DisplayDestroyedListener *>(listener)->parent;
        that->m_global = nullptr;
    }

    void dde_surface_manager::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        Q_ASSERT(resource);
        dde_surface_manager *that = resource->dde_surface_manager_object;
        if (Q_LIKELY(that)) {
            that->m_resource_map.remove(resource->client(), resource);
            that->dde_surface_manager_destroy_resource(resource);

            that = resource->dde_surface_manager_object;
            if (that && that->m_resource == resource)
                that->m_resource = nullptr;
        }
        delete resource;
    }

    dde_surface_manager::Resource *dde_surface_manager::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::dde_surface_manager_interface, version, id);
        return bind(handle);
    }

    dde_surface_manager::Resource *dde_surface_manager::bind(struct ::wl_resource *handle)
    {
        Resource *resource = dde_surface_manager_allocate();
        resource->dde_surface_manager_object = this;

        wl_resource_set_implementation(handle, &m_dde_surface_manager_interface, resource, destroy_func);
        resource->handle = handle;
        dde_surface_manager_bind_resource(resource);
        return resource;
    }
    dde_surface_manager::Resource *dde_surface_manager::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (Q_UNLIKELY(!resource))
            return nullptr;
        if (wl_resource_instance_of(resource, &::dde_surface_manager_interface, &m_dde_surface_manager_interface))
            return static_cast<Resource *>(wl_resource_get_user_data(resource));
        return nullptr;
    }

    const struct ::dde_surface_manager_interface dde_surface_manager::m_dde_surface_manager_interface = {
        dde_surface_manager::handle_get_surface
    };

    void dde_surface_manager::dde_surface_manager_get_surface(Resource *, uint32_t, struct ::wl_resource *)
    {
    }


    void dde_surface_manager::handle_get_surface(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        struct ::wl_resource *surface)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_surface_manager_object)) {
            return;
        }
        static_cast<dde_surface_manager *>(r->dde_surface_manager_object)->dde_surface_manager_get_surface(
            r,
            id,
            surface);
    }

    dde_shell_surface::dde_shell_surface(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(client, id, version);
    }

    dde_shell_surface::dde_shell_surface(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(display, version);
    }

    dde_shell_surface::dde_shell_surface(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(resource);
    }

    dde_shell_surface::dde_shell_surface()
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
    }

    dde_shell_surface::~dde_shell_surface()
    {
        for (auto resource : qAsConst(m_resource_map))
            resource->dde_shell_surface_object = nullptr;

        if (m_resource)
            m_resource->dde_shell_surface_object = nullptr;

        if (m_global) {
            wl_global_destroy(m_global);
            wl_list_remove(&m_displayDestroyedListener.link);
        }
    }

    void dde_shell_surface::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void dde_shell_surface::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    dde_shell_surface::Resource *dde_shell_surface::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    dde_shell_surface::Resource *dde_shell_surface::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void dde_shell_surface::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::dde_shell_surface_interface, version, this, bind_func);
        m_globalVersion = version;
        m_displayDestroyedListener.notify = dde_shell_surface::display_destroy_func;
        m_displayDestroyedListener.parent = this;
        wl_display_add_destroy_listener(display, &m_displayDestroyedListener);
    }

    const struct wl_interface *dde_shell_surface::interface()
    {
        return &::dde_shell_surface_interface;
    }

    dde_shell_surface::Resource *dde_shell_surface::dde_shell_surface_allocate()
    {
        return new Resource;
    }

    void dde_shell_surface::dde_shell_surface_bind_resource(Resource *)
    {
    }

    void dde_shell_surface::dde_shell_surface_destroy_resource(Resource *)
    {
    }

    void dde_shell_surface::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        dde_shell_surface *that = static_cast<dde_shell_surface *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void dde_shell_surface::display_destroy_func(struct ::wl_listener *listener, void *data)
    {
        Q_UNUSED(data);
        dde_shell_surface *that = static_cast<dde_shell_surface::DisplayDestroyedListener *>(listener)->parent;
        that->m_global = nullptr;
    }

    void dde_shell_surface::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        Q_ASSERT(resource);
        dde_shell_surface *that = resource->dde_shell_surface_object;
        if (Q_LIKELY(that)) {
            that->m_resource_map.remove(resource->client(), resource);
            that->dde_shell_surface_destroy_resource(resource);

            that = resource->dde_shell_surface_object;
            if (that && that->m_resource == resource)
                that->m_resource = nullptr;
        }
        delete resource;
    }

    dde_shell_surface::Resource *dde_shell_surface::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::dde_shell_surface_interface, version, id);
        return bind(handle);
    }

    dde_shell_surface::Resource *dde_shell_surface::bind(struct ::wl_resource *handle)
    {
        Resource *resource = dde_shell_surface_allocate();
        resource->dde_shell_surface_object = this;

        wl_resource_set_implementation(handle, &m_dde_shell_surface_interface, resource, destroy_func);
        resource->handle = handle;
        dde_shell_surface_bind_resource(resource);
        return resource;
    }
    dde_shell_surface::Resource *dde_shell_surface::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (Q_UNLIKELY(!resource))
            return nullptr;
        if (wl_resource_instance_of(resource, &::dde_shell_surface_interface, &m_dde_shell_surface_interface))
            return static_cast<Resource *>(wl_resource_get_user_data(resource));
        return nullptr;
    }

    const struct ::dde_shell_surface_interface dde_shell_surface::m_dde_shell_surface_interface = {
        dde_shell_surface::handle_get_geometry,
        dde_shell_surface::handle_set_property,
        dde_shell_surface::handle_get_property
    };

    void dde_shell_surface::dde_shell_surface_get_geometry(Resource *)
    {
    }

    void dde_shell_surface::dde_shell_surface_set_property(Resource *, const QString &, wl_array *)
    {
    }

    void dde_shell_surface::dde_shell_surface_get_property(Resource *, const QString &)
    {
    }


    void dde_shell_surface::handle_get_geometry(
        ::wl_client *client,
        struct wl_resource *resource)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_shell_surface_object)) {
            return;
        }
        static_cast<dde_shell_surface *>(r->dde_shell_surface_object)->dde_shell_surface_get_geometry(
            r);
    }

    void dde_shell_surface::handle_set_property(
        ::wl_client *client,
        struct wl_resource *resource,
        const char *name,
        wl_array *value)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_shell_surface_object)) {
            return;
        }
        static_cast<dde_shell_surface *>(r->dde_shell_surface_object)->dde_shell_surface_set_property(
            r,
            QString::fromUtf8(name),
            value);
    }

    void dde_shell_surface::handle_get_property(
        ::wl_client *client,
        struct wl_resource *resource,
        const char *name)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        if (Q_UNLIKELY(!r->dde_shell_surface_object)) {
            return;
        }
        static_cast<dde_shell_surface *>(r->dde_shell_surface_object)->dde_shell_surface_get_property(
            r,
            QString::fromUtf8(name));
    }

    void dde_shell_surface::send_geometry(int32_t x, int32_t y, int32_t w, int32_t h)
    {
        Q_ASSERT_X(m_resource, "dde_shell_surface::geometry", "Uninitialised resource");
        if (Q_UNLIKELY(!m_resource)) {
            qWarning("could not call dde_shell_surface::geometry as it's not initialised");
            return;
        }
        send_geometry(
            m_resource->handle,
            x,
            y,
            w,
            h);
    }

    void dde_shell_surface::send_geometry(struct ::wl_resource *resource, int32_t x, int32_t y, int32_t w, int32_t h)
    {
        dde_shell_surface_send_geometry(
            resource,
            x,
            y,
            w,
            h);
    }


    void dde_shell_surface::send_property(const QString &name, const QByteArray &value)
    {
        Q_ASSERT_X(m_resource, "dde_shell_surface::property", "Uninitialised resource");
        if (Q_UNLIKELY(!m_resource)) {
            qWarning("could not call dde_shell_surface::property as it's not initialised");
            return;
        }
        send_property(
            m_resource->handle,
            name,
            value);
    }

    void dde_shell_surface::send_property(struct ::wl_resource *resource, const QString &name, const QByteArray &value)
    {
        struct wl_array value_data;
        value_data.size = value.size();
        value_data.data = static_cast<void *>(const_cast<char *>(value.constData()));
        value_data.alloc = 0;

        dde_shell_surface_send_property(
            resource,
            name.toUtf8().constData(),
            &value_data);
    }

}

QT_WARNING_POP
QT_END_NAMESPACE
